<?php

function connect_database(){
     // Database credentials
     $servername = "localhost";  // Replace with your server name
     $username = "getsway_admin";     // Replace with your database username
     $password = "MTu3FVaQPQeb";     // Replace with your database password
     $dbname = "getsway_mintpest_fieldrouts";       // Replace with your database name
     
     // Create connection
     $conn = new mysqli($servername, $username, $password, $dbname);
     return $conn;
}

function insert_appointment_id($appointment_id) {
    if(!empty($appointment_id)) {
       
        $conn = connect_database();

        // SQL update statement
        $sql = "UPDATE fieldrouts SET application_Id='$appointment_id' WHERE Id='1'";
        $conn->query($sql);
    
        // Close connection
        $conn->close();
    }
}

function get_last_appointment_id() {
    $conn = connect_database();
    
    $sql = "SELECT application_Id FROM fieldrouts WHERE id = '1'";
    $result = $conn->query($sql);
    if ($result->num_rows > 0) return $result->fetch_assoc();

    $conn->close();
    
}


/**
 * retrieve previous date from  EDT timezone
 */
function get_previous_date_edt(){

    $timezone = new DateTimeZone('America/New_York'); // Set the timezone to EDT
    $now = new DateTime('now', $timezone); // Create a DateTime object for the current date/time
    $now->sub(new DateInterval('P1D')); // Subtract one day
    $previous_date = $now->format('Y-m-d'); // Format the date according to your needs

    return $previous_date;
}

/**
 * inser fieldrouts data to the google sheet
 * @param string $sheetID the id of the google sheet to
 * @param string $sheetName the name of the google sheet
 * @param array $data the data to be inserted
 * 
 * @return boolean whether the data is inserted  or not
 */
function insert_data_google_sheet($sheetID = '', $sheetName = '', $data = []){
    $client = new \Google_Client();
    $client->setApplicationName('Google Sheets with Primo');
    $client->setScopes([\Google_Service_Sheets::SPREADSHEETS]);
    $client->setAccessType('offline');
    $client->setAuthConfig(__DIR__ . '/credentials.json');

    $service = new Google_Service_Sheets($client);
    $spreadsheetId = $sheetID;
    $range = $sheetName;

    try {
        // Check the existing values in the sheet
        $response = $service->spreadsheets_values->get($spreadsheetId, $range);
        $existingValues = $response->getValues();
    } catch (Exception $e) {
        die('Error retrieving existing values: ' . $e->getMessage());
    }


    // Extract existing appointment IDs to check for duplicates
    $existingIds = array_column($existingValues, 0);

    // Filter out duplicates
    $filteredData = array_filter($data, function ($row) use ($existingIds) {
        return !in_array($row[0], $existingIds);
    });
    
    if (empty($filteredData)) {
        echo "No new data to insert.";
        return;
    }

    // Define the range to append data starting from the next row
    $values = array_values($filteredData); // array_values to reindex filteredData array
    $body = new Google_Service_Sheets_ValueRange([
        'values' => $values
    ]);
    $params = [
        'valueInputOption' => 'RAW'
    ];

    $result = $service->spreadsheets_values->append(
        $spreadsheetId,
        $range,
        $body,
        $params
    );

    if ($result->updates->updatedRows > 0) {
        echo "Success";
    } else {
        echo "Fail";
    }
}